UNIT constsU;

INTERFACE

CONST 
   fclk=16e6; //Abtastrate
   fh=15625;  //Zeilenfrequenz
   fsck=1135/4*fh;  //Untertraegerfrequenz
   llen=1024;

  //Horizontale Position der Elemente   
  //Relativ zum Anfang (50%) des Hsyncs
   bpos=90; //Burstanfang bei TZ 90
   cpos=298; //Anfang der Farbbalken (des eigentlichen Bildes)
   
  //Pegel
    sync=0;
    black=0.3;
    white=1;
   
   
VAR sphase:integer; //# des Abtastwertes der Zeile
    palline:integer;//PAL-Zeile 0-3
   
PROCEDURE writesample(w2,sn:integer);
FUNCTION modul(y,u,v:double):integer;


IMPLEMENTATION
PROCEDURE writesample(w2,sn:integer);
VAR n:integer;
BEGIN
  IF w2>31 THEN w2:=31;
  IF w2<0 THEN w2:=0;
  write('  OUT PORTA,r',w2,'; ');
  IF w2<10 THEN write(' ');
  write(sn:5);
  FOR n:=0 TO w2 DO write(' ');
  writeln('|');
END;

FUNCTION modul(y,u,v:double):integer;
VAR ph:double;
   palphase:integer;
   w:double;
   w2,n:integer;
BEGIN
  palphase:=(palline MOD 2)*2-1;
  ph:=((sphase+palline*llen)/fclk)*2*pi*fsck;
  w:=y+u*sin(ph)+v*cos(ph)*palphase;
  w2:=round(w*32);
  IF w2>31 THEN w2:=31;
  IF w2<0 THEN w2:=0;
  modul:=w2;
  inc(sphase);
END;


BEGIN
  sphase:=0;
  palline:=1;
END.
