PROGRAM makesignals;
USES constsU;

CONST slen=1016;
      

VAR f:text;
   ay,au,av:ARRAY[0..slen-1] OF double;


PROCEDURE writeline(pol:integer;name:string);
VAR s:string;
    n,an,x:integer;
    rest:integer;
    samples:ARRAY[0..slen-1] OF integer;
BEGIN
  palline:=pol;
  sphase:=0;
   
 FOR n:=0 TO slen-1 DO
    samples[n]:=modul(ay[n],au[n],av[n]);
{ FOR n:=0 TO slen-1 DO
    writesample(samples[n],n);
 } 
  an:=0;
  {writesample(samples[an],an);}
  FOR n:=1 TO slen-1 DO
  BEGIN
    IF (samples[an]<>samples[n]) OR (n>=slen-1) THEN
    BEGIN
      writesample(samples[an],an);
      rest:=(n-an)-1;
      while (rest>100) DO
      BEGIN
        writeln('  call delay_100');
        rest:=rest-100;
      END;
      while (rest>10) DO
      BEGIN
        writeln('  call delay_10');
        rest:=rest-10;
      END;
      FOR x:=n-rest TO n-1 DO
        writeln('  nop ;',x);
//         writesample(samples[x],x);
      an:=n;  
    END;
  END;
  FOR x:=an TO slen-1 DO
    writesample(samples[x],x);
  writeln('ret');
END;


PROCEDURE writelinefull(name:string);
BEGIN
  writeln(name,'_0:');
  writeline(0,name);
  writeln(name,'_1:');
  writeline(1,name);
  writeln(name,'_2:');
  writeline(2,name);
  writeln(name,'_3:');
  writeline(3,name);
END;

PROCEDURE writelinemono(name:string);
BEGIN
{  writeln(name,'_0:');
  writeln(name,'_2:');
  writeline(0,name);
  writeln(name,'_1:');
  writeln(name,'_3:');
  writeline(1,name);}
writelinefull(name);
END;

PROCEDURE writelinenoburst(name:string);
BEGIN
  writeln(name,'_0:');  
  writeln(name,'_1:');
  writeln(name,'_2:');
  writeln(name,'_3:');
  writeline(-1,name);
END;


PROCEDURE fill(start,stop:integer;y,u,v:double);
VAR n:integer;
BEGIN
  FOR n:=start TO stop DO
  BEGIN
    ay[n]:=y;
    au[n]:=u;
    av[n]:=v;
  END;
END;

PROCEDURE emptyline;
BEGIN
  fill(0,slen-1,black,0,0);
END;

PROCEDURE machburst_hsync;
BEGIN
  fill(0,75,sync,0,0);
  fill(90,126,black,-0.106,0.106);
END;

PROCEDURE fillcolour(start,stop:integer;r,g,b:double);
VAR y,u,v:double;
BEGIN
  y:=0.299*r+0.587*g+0.114*b;
  u:=0.493*(b-y);
  v:=0.877*(r-y);
  fill(start,stop,(y*(white-black))+black,u,v);
END;


PROCEDURE mbburst(von,bis:integer; freq:double);
VAR n:integer;
BEGIN
  FOR n:=von TO bis DO
    fill(n,n,(sin(n/fclk*2*pi*freq)*0.5+0.5)*white+black,0,0);
END;

PROCEDURE gridline;
VAR n:integer;
BEGIN
  emptyline;
  machburst_hsync;
  fill(166,998,black+0.1*white,0,0);
  FOR n:=-10 TO 10 DO
    fill(582+n*40,582+n*40+1,white,0,0);
  writelinemono('grid');
  fillcolour(344,403,0.75,0.75,0.75);
  fillcolour(404,463,0.75,0.75,0   );
  fillcolour(464,523,0   ,0.75,0.75);
  fillcolour(524,583,0   ,0.75,0   );
  fillcolour(584,643,0.75,0   ,0.75);
  fillcolour(644,703,0.75,0   ,0   );
  fillcolour(704,763,0   ,0   ,0.75);
  fillcolour(764,821,0   ,0   ,0   );
  writelinefull('cgrid');
  fillcolour(344,439,0  ,0  ,0  );
  fillcolour(439,534,0.25,0.25,0.25);
  fillcolour(534,631,0.5,0.5,0.5);
  fillcolour(632,726,0.75,0.75,0.75);
  fillcolour(727,822,1,1,1);
  fill(582,582+1,white,0,0);
  writelinemono('cramp');
  fill(344,821,black+0.5*white,0,0);
//  mbburst(400,440,0.5e6);
  mbburst(450,490,1e6);
//  mbburst(500,540,1.5e6);
  mbburst(550,590,2e6);
  mbburst(600,640,3e6);
  mbburst(650,690,4e6);
  mbburst(700,740,4.443e6);
  mbburst(750,790,4.886e6);
  writelinemono('mburst');
END;

PROCEDURE cgridl;
BEGIN
  emptyline;
  machburst_hsync;
  fill(166,998,white,0,0);
  fillcolour(344,403,0.75,0.75,0.75);
  fillcolour(404,463,0.75,0.75,0   );
  fillcolour(464,523,0   ,0.75,0.75);
  fillcolour(524,583,0   ,0.75,0   );
  fillcolour(584,643,0.75,0   ,0.75);
  fillcolour(644,703,0.75,0   ,0   );
  fillcolour(704,763,0   ,0   ,0.75);
  fillcolour(764,821,0   ,0   ,0   );
  writelinefull('cgridl');
END;


PROCEDURE colourline(y,u,v:double;name:string);
BEGIN
  emptyline;
  machburst_hsync;
  fill(166,998,y,u,v);
  writelinemono(name);
END;

PROCEDURE vsync;
BEGIN
  emptyline;
  fill(0,37,sync,0,0);
  fill(512,549,sync,0,0);
  writelinenoburst('vsync_trab'); //2 Trabanten
  emptyline;
  fill(0,37,sync,0,0);
  fill(512,949,sync,0,0);
  writelinenoburst('vsync_trab_vsync');
  emptyline;
  fill(0,436,sync,0,0);
  fill(512,949,sync,0,0);
  writelinenoburst('vsync_vsync');
  emptyline;
  fill(0,436,sync,0,0);
  fill(512,549,sync,0,0);
  writelinenoburst('vsync_vsync_trab');
END;

PROCEDURE colourbars;
BEGIN
  emptyline;
  machburst_hsync;
  fillcolour(166,269,1   ,1   ,1   );
  fillcolour(270,373,0.75,0.75,0   );
  fillcolour(374,477,0   ,0.75,0.75);
  fillcolour(478,581,0   ,0.75,0   );
  fillcolour(582,685,0.75,0   ,0.75);
  fillcolour(686,789,0.75,0   ,0   );
  fillcolour(790,893,0   ,0   ,0.75);
  writelinefull('cbars');
END;

PROCEDURE ramp;
VAR n:integer;
    h:double;
BEGIN
  emptyline;
  machburst_hsync;
  FOR n:=0 TO 832 DO
  BEGIN
    h:=n/832;
    fillcolour(n+166,n+166,h,h,h);
  END;
  writelinemono('ramp');
END;



BEGIN
  vsync;
  colourline(black,0,0,'black');
  colourline(white,0,0,'white');
  gridline;
  cgridl;
//  colourbars;
//  ramp;
END.
